import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import "core-js/modules/es7.symbol.async-iterator";
import "core-js/modules/es6.symbol";
import "core-js/modules/web.dom.iterable";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component, createRef } from 'react';
import classnames from 'classnames';
import PropTypes from 'prop-types';
import withStyles from '@material-ui/core/styles/withStyles'; // https://developers.google.com/web/fundamentals/performance/lazy-loading-guidance/images-and-video/

function lazyLoadImages(element) {
  if (!element) return;

  var lazyImages = _toConsumableArray(element.querySelectorAll('[data-rsf-lazy]'));

  if (!lazyImages.length) return;
  var lazyImageObserver;

  var load = function load(img) {
    img.src = img.dataset.src;
    img.removeAttribute('data-rsf-lazy');

    if (lazyImageObserver) {
      lazyImageObserver.unobserve(lazyImage);
    }
  };

  var observerHandler = function observerHandler(entries) {
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = entries[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var entry = _step.value;

        if (entry.isIntersecting) {
          load(entry.target);
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  };

  try {
    lazyImageObserver = new window.IntersectionObserver(observerHandler);
    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = lazyImages[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var img = _step2.value;
        lazyImageObserver.observe(img);
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }
  } catch (e) {
    // eagerly load images when we don't have the observer
    var _iteratorNormalCompletion3 = true;
    var _didIteratorError3 = false;
    var _iteratorError3 = undefined;

    try {
      for (var _iterator3 = lazyImages[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
        var _img = _step3.value;
        load(_img);
      }
    } catch (err) {
      _didIteratorError3 = true;
      _iteratorError3 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
          _iterator3.return();
        }
      } finally {
        if (_didIteratorError3) {
          throw _iteratorError3;
        }
      }
    }
  }
}

export var styles = function styles(theme) {
  return {
    inline: {
      display: 'inline'
    },
    block: {
      display: 'block'
    },
    root: {
      '& .rsf-presized-img': {
        position: 'relative',
        '& img': {
          position: 'absolute',
          height: '100%',
          width: '100%',
          top: 0,
          left: 0
        }
      },
      '& img[data-rsf-lazy]': {
        visibility: 'hidden'
      }
    }
  };
};
/**
 * A container for HTML blob content from a CMS.  Content is dangerously inserted into the DOM.
 * Pass the html as a string as the child of this component. Additional props are spread to the
 * rendered span element.
 */

var CmsSlot = (_dec = withStyles(styles, {
  name: 'RSFCmsSlot'
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(CmsSlot, _Component);

  function CmsSlot(_ref) {
    var _this;

    var lazyLoadImages = _ref.lazyLoadImages;

    _classCallCheck(this, CmsSlot);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CmsSlot).call(this));

    if (lazyLoadImages) {
      _this.el = createRef();
    }

    return _this;
  }

  _createClass(CmsSlot, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.lazyLoadImages) {
        lazyLoadImages(this.el.current);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.props.lazyLoadImages) {
        lazyLoadImages(this.el.current);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames;

      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          classes = _this$props.classes,
          inline = _this$props.inline,
          lazyLoadImages = _this$props.lazyLoadImages,
          others = _objectWithoutProperties(_this$props, ["children", "className", "classes", "inline", "lazyLoadImages"]);

      return children ? React.createElement("span", _extends({}, others, {
        ref: this.el,
        className: classnames(className, classes.root, (_classnames = {}, _defineProperty(_classnames, classes.inline, inline), _defineProperty(_classnames, classes.block, !inline), _classnames)),
        dangerouslySetInnerHTML: {
          __html: children
        }
      })) : null;
    }
  }]);

  return CmsSlot;
}(Component), _defineProperty(_class2, "proptypes", {
  /**
   * Use inline prop to use display:inline style
   */
  inline: PropTypes.boolean,

  /**
   * Set to true to lazy load images that have been preprocessed with `$.lazyLoadImages()`.
   */
  lazyLoadImages: PropTypes.boolean
}), _defineProperty(_class2, "defaultProps", {
  lazyLoadImages: false
}), _temp)) || _class);
export { CmsSlot as default };
//# sourceMappingURL=CmsSlot.js.map